//
//  PhobosDataManager.h
//  GMCache
//
//  Created by Locus on 2020/1/21.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, PhobosModelSendStatus) {
    PhobosModelSendStatusNormal = 0,
    PhobosModelSendStatusToBeSend,
    PhobosModelSendStatusSending,
    PhobosModelSendStatusFinish,
    PhobosModelSendStatusError,
};

@interface PhobosSendModel : NSObject

@property (nonatomic, copy, readonly) NSString *sendId;
@property (nonatomic, strong) id data;
@property (nonatomic, copy) NSString *sendAPI;
@property (nonatomic, assign) PhobosModelSendStatus sendStatus;

- (instancetype)initWithData:(id)data sendAPI:(NSString *)api;

@end

@interface PhobosDataManager : NSObject

+ (void)insertData:(NSDictionary *)data sendAPI:(NSString *)v immediately:(BOOL)immediately;
+ (void)updateDataModel:(PhobosSendModel *)model sendStatus:(PhobosModelSendStatus)sendStatus;
+ (void)deleteDataModel:(PhobosSendModel *)model;
+ (void)removeAllDataWithImmediately:(BOOL)immediately;
+ (NSArray<PhobosSendModel *> *)fetchDataModelsWithStatus:(PhobosModelSendStatus)stauts;

+ (void)sendData;

@end

NS_ASSUME_NONNULL_END
